﻿local E = AleaUI
local CBF = E:Module("ClassBars")

local class1, class = UnitClass("player")
if class ~= "MONK" then return end

local maxw, maxh = 200, 10

local lastmaxpower = 4

local f

local function UpdateBarSeparator()

	for i=1, #f.bar.separators do
		f.bar.separators[i]:Hide()
	end
	
	for i=1, lastmaxpower-1 do
	
		local s = f.bar.separators[i] or f.bar:CreateTexture()
		s:SetDrawLayer('ARTWORK', 1)
		s:SetSize(1, maxh)
		s:SetColorTexture(0,0,0,1)
		s:ClearAllPoints()
		s:SetPoint('LEFT', f.bar, 'LEFT', maxw/lastmaxpower*i, 0)
		s:Show()
		
		f.bar.separators[i] = s
	end
end

local function ChiBar()

	f = CreateFrame("Frame", nil, E.UIParent)
	E:Mover(f, "chibarFrame", maxw, maxh)
	
	f.orbs = {}
	f.eventlist = { 
		["UNIT_POWER"]		= "player",
		["UNIT_MAXPOWER"]	= "player",
	}


	f:SetSize(maxw, maxh)
		
	local o = CreateFrame("StatusBar", nil, f)
	o:SetSize(maxw, maxh)
	o:SetStatusBarTexture([[Interface\Buttons\WHITE8x8]])
	o:SetPoint("LEFT", f, "LEFT", 0, 0)
	o:SetStatusBarColor(0, 255/255, 150/255 ,1)
	o:SetMinMaxValues(0,1)
	
	o.art = CreateFrame("Frame", nil, o)
	o.art:SetFrameLevel(o:GetFrameLevel()-1)
	o.art:SetBackdrop({
	  bgFile = [[Interface\Buttons\WHITE8x8]], 
	  edgeFile = [[Interface\Buttons\WHITE8x8]], 
	  edgeSize = 1, 
	})
	o.art:SetBackdropColor(0*0.4,255/255*0.4,150/255*0.4, 1)
	o.art:SetBackdropBorderColor(0,0,0,1)
	o.art:SetPoint('TOPLEFT', o, 'TOPLEFT', -1, 1)
	o.art:SetPoint('BOTTOMRIGHT', o, 'BOTTOMRIGHT', 1, -1)

	f.bar = o
	
	f.bar.separators = {}
	
	for i=1, 4 do
		local s = f.bar:CreateTexture()
		s:SetDrawLayer('ARTWORK', 1)
		s:SetSize(1, maxh)
		s:SetColorTexture(0,0,0,1)
		s:SetPoint('LEFT', f.bar, 'LEFT', maxw/5*i, 0)
		
		f.bar.separators[i] = s
	end
	
	function f:UNIT_POWER(event, unit, powerType)	
		if unit == "player" and powerType == "CHI" then
			local power = UnitPower("player", SPELL_POWER_CHI)
			local maxLight = UnitPowerMax("player", SPELL_POWER_CHI );
			
			self.bar:SetMinMaxValues(0, maxLight)
			self.bar:SetValue(power)
			
			if lastmaxpower ~= maxLight then
				lastmaxpower = maxLight
				
				UpdateBarSeparator()
			end
		end
	end

	f.UNIT_MAXPOWER = f.UNIT_POWER
	
	f:UNIT_POWER(_, "player", "CHI")
	
	E.GUI.args.unitframes.args.classBars.args.unlock = {
		name = "Разблокировать",
		order = 2,
		type = "execute",
		set = function(self, value)
			E:UnlockMover("chibarFrame") 
		end,
		get = function(self)end
	}
	
	return f
end

CBF:AddClassBar(class, 1, ChiBar)
CBF:AddClassBar(class, 2, ChiBar)
CBF:AddClassBar(class, 3, ChiBar)